import java.awt.Graphics;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.WindowConstants;

import JTwilight.GlobalVar;
import JTwilight.Transaction;




public class AnimatedClock {

	public static class AnimationPanel extends JPanel {
		private static final long serialVersionUID = 1L;
		private GlobalVar<Integer> x = new GlobalVar<Integer>(0);
		private GlobalVar<Integer> y = new GlobalVar<Integer>(10);
		private GlobalVar<Boolean> right = new GlobalVar<Boolean>(Boolean.valueOf(true));
		
		public synchronized void paintComponent (final Graphics g) {
			
			Transaction.execute(new Transaction.TransactionBody<Void>() {
				
				public void transactional() {
					stm.read(x);
					stm.read(y);
				}

				public Void twilight() {
					AnimationPanel.super.paintComponent(g);
					g.fillRect(stm.read(x),stm.read(y), 50, 20);
					g.drawOval(10,50,300,300);
					g.fillArc(10, 50, 300, 300, 0, stm.read(x));
					return null;
				}
			}, null);
		}
		
		public synchronized void next() {
			Transaction.execute(new Transaction.TransactionBody<Void>() {

				public void transactional() {
					if (stm.read(right)) {
						stm.write(x, stm.read(x) + 1);
						if (stm.read(x) == 360) {
							stm.write(right,false);
						} 
					} else {
						stm.write(x, stm.read(x) - 1);
						if (stm.read(x) == 0) {
							stm.write(right,true);
						}
					}
				}
				
				public Void twilight() {
					return null;
				}
			},null);
			repaint();
		}
	}
	
	public static class Animator extends Thread {
		private AnimationPanel animPanel;
		
		public Animator(AnimationPanel a) {
			animPanel = a;
		}
		
		public void run() {
			while(true) {
				animPanel.next();
				try {
					Thread.sleep(60);
				} catch (InterruptedException e) {
				}
			}
		}
		
	}
	
	public static void main (String[] args) {
		JFrame f = new JFrame("Animation");
		f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		AnimationPanel a = new AnimationPanel();
		f.add(a);
		f.setLocation(100, 100);
		f.setSize(400, 400);
		f.setVisible(true);
		
		Animator animThread = new Animator(a);
		animThread.start();
	}
	
}
