import JTwilight.GlobalVar;
import JTwilight.Transaction;


public class Counter {
	final static int NUM_THREADS = 8;
	final static GlobalVar<Integer> count=new GlobalVar<Integer>(0);
	
	static class TestTrans extends Transaction.TransactionBody<Void> {
		int local_counter;
		@Override
		public void transactional() {
			local_counter = stm.read(count) + 1;
			try {
				Thread.sleep((int) (Math.random()*1000));
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			stm.write(count,local_counter);
		}

		@Override
		public Void twilight() {
			if (!stm.inconsistencies().isEmpty()) {	
				stm.atomize();
				local_counter = stm.read(count) + 1;
				stm.write(count, local_counter);
				System.out.println("Saved!"+ local_counter);
			} else {
				System.out.println("Not saved!" + local_counter);
			}
			return null;
		}
		
	};
	
	public static class Tester extends Thread {
		public void run() {
			Transaction.execute(new TestTrans(), null);
		}
	}
	
	public static void main(String[] args) {
		
		Tester threads[] = new Tester[NUM_THREADS];

		System.out.println("Initializing transactions");
		for (int i = 0; i < NUM_THREADS; ++i) {
			threads[i] = new Tester();
		}
		
		for (int i = 0; i < NUM_THREADS; ++i) {
			threads[i].start();
		}

	}

}
