package JTwilight;

import java.util.concurrent.locks.ReentrantLock;


//wrapper for global variables. This wrapper is required in order to
// associate each value with a lock and a version.
public class GlobalVar<T> implements Comparable<GlobalVar<?>> {
	volatile int _version;
	volatile T _value;
	volatile ReentrantLock _lock;

	public GlobalVar(T value) {
		_version = 0;
		_value = value;
		_lock = new ReentrantLock();
	}

	// make sure that we can order the global variables such that we lock
	// them in the appropriate order. 
	public int compareTo(GlobalVar<?> other) {
		return hashCode() - other.hashCode();
	}
}