

public class RBTest {
    private final static int N = 50;
    private final static int M = 2000;
    
	
	public static void main(String[] args) {
        final RBTree tree = new RBTree();
        Thread[] threads = new Thread[N];
        
        for(int i=0; i < N; i++) {
            final int start = i;
            
            threads[i] = new Thread(new Runnable() {
                    public void run() {
                        for(int j=0; j < M; j++) {
                            tree.insert(start*M+j);
                        }
                        for(int j=0; j < (M-1); j++) {
                            tree.delete(start*M+j);
                        }
                        if (tree.search((start+1) * M -1) == null) {
                            throw new RuntimeException("Invariant failure: element should be there :(");
                        }
                    }
            });
        }
        
        for (Thread t : threads) {
            t.start();
        }
        
        for (Thread t : threads) {
            try { t.join(); }
            catch(InterruptedException e) {}
        }
        
        for(int i=0; i < N; i++) {
            if (tree.search((i+1) * M -1) == null) {
                throw new RuntimeException("Final check failure: element should be there :(");
            }
        }
        
        System.out.println(tree.toString());
	}
}
